import { getDojoClient, getGuildForRequest } from "@/src/services/guildService";
import { RequestHandler } from "express";

export const destroyDojoDecoController: RequestHandler = async (req, res) => {
    const guild = await getGuildForRequest(req);
    const request = JSON.parse(String(req.body)) as IDestroyDojoDecoRequest;
    const component = guild.DojoComponents.id(request.ComponentId)!;
    const decoIndex = component.Decos!.findIndex(x => x._id.equals(request.DecoId));
    component.Decos!.splice(decoIndex, 1);
    // TODO: The client says this is supposed to refund the resources to the clan vault, so we should probably do that.
    await guild.save();
    res.json(getDojoClient(guild, 0));
};

interface IDestroyDojoDecoRequest {
    DecoType: string;
    ComponentId: string;
    DecoId: string;
}
